| Elektra 0.11.0

Public Member Functions | List of all members
org.libelektra.NativePlugin Class Reference

This class can be used to load native Elektra plugins to be used by Java directly. More...

Inheritance diagram for org.libelektra.NativePlugin:

## Public Member Functions
| NativePlugin (String pluginName, Key errorKey, KeySet modules) throws InstallationException
| Constructor for loading an Elektra plugin.
| NativePlugin (String pluginName, KeySet modules, KeySet config, Key errorKey)
| Constructor for loading an Elektra plugin.
KeySet | getConfig ()
| Gets the config which was used to configure the plugin.
int | open (KeySet conf, Key errorKey)
| Calls the plugin's open function.
int | kdbOpen (Key errorKey)
| Opens the session with the KeyDatabase.
int | close (Key errorKey)
| Closes the session with the Key database.
int | set (KeySet keySet, Key errorKey) throws KDBException
| Lets the plugin transform the given KeySet.
Public Member Functions inherited from org.libelektra.Plugin
String | getName ()
int | open (KeySet config, Key errorKey)
| Calls the plugin's open function.
int | get (KeySet keySet, Key parentKey) throws KDBException
| Calls the plugin's get function.
int | set (KeySet keySet, Key parentKey) throws KDBException
| Calls the set function of the plugin.
int | error (KeySet keySet, Key parentKey)
| Calls the error function of the plugin.
int | close (Key parentKey)
| Calls the close function of the plugin.

## Additional Inherited Members
Static Public Attributes inherited from org.libelektra.Plugin
static final String | JNI_MODULE_CONTRACT_ROOT = "system:/elektra/modules/jni"
| This is the root key of the JNI plugin wrapping a Java plugin for use by Elektra.
static final String | PROCESS_CONTRACT_ROOT = "system:/elektra/modules/java"
| This is the root key of the process plugin wrapping a Java plugin for use by Elektra.
static final int | STATUS_ERROR = -1
| Return value for plugin methods: An error occurred inside the plugin function.
static final int | STATUS_SUCCESS = 1
| Return value for plugin methods: Everything went fine.
static final int | STATUS_NO_UPDATE = 0
| Return value for plugin methods: Everything went fine and the function did not update the given key set / configuration.

## Detailed Description

This class can be used to load native Elektra plugins to be used by Java directly.

## Constructor & Destructor Documentation

## ◆ NativePlugin() [1/2]

org.libelektra.NativePlugin.NativePlugin | ( | String | pluginName,
|  | Key | errorKey,
|  | KeySet | modules
| ) |  | throws InstallationException
| inline

Constructor for loading an Elektra plugin.

Parameters

  pluginName | The plugin name
  errorKey | The errorKey
  modules | TODO #3754 add parameter description

Exceptions

  InstallationException | if the plugin does not exist
  IllegalStateException | if `modules` or `errorKey` has already been released

## ◆ NativePlugin() [2/2]

org.libelektra.NativePlugin.NativePlugin | ( | String | pluginName,
|  | KeySet | modules,
|  | KeySet | config,
|  | Key | errorKey
| ) |  |
| inline

Constructor for loading an Elektra plugin.

Parameters

  pluginName | The plugin name
  errorKey | The errorKey
  config | TODO #3754 add parameter description and update other
  modules | TODO #3754 add parameter description and update other

Exceptions

  IllegalStateException | if `modules`, `config` or `errorKey` has already been released

## Member Function Documentation

## ◆ close()

int org.libelektra.NativePlugin.close | ( | Key | errorKey | ) |
| inline

Closes the session with the Key database.

Parameters

  errorKey | must be a valid key, e.g. created with Key.create()

Returns
  0 if success or -1 otherwise

Implements org.libelektra.Plugin.

## ◆ getConfig()

KeySet org.libelektra.NativePlugin.getConfig | ( |  | ) |
| inline

Gets the config which was used to configure the plugin.

Returns
  A KeySet containing the configuration of the plugin

## ◆ kdbOpen()

int org.libelektra.NativePlugin.kdbOpen | ( | Key | errorKey | ) |
| inline

Opens the session with the KeyDatabase.

Parameters

  errorKey | must be a valid key, e.g. created with Key.create()

Returns
  0 if success or -1 otherwise

Exceptions

  IllegalStateException | if `errorKey` has already been released

## ◆ open()

int org.libelektra.NativePlugin.open | ( | KeySet | config,
|  | Key | errorKey
| ) |  |
| inline

Calls the plugin's open function.

Parameters

  config | Plugin configuration key set
  errorKey | Used to store warnings and error information

Returns
  Plugin's return value for open

See also
  #STATUS_SUCCESS
  #STATUS_ERROR

Implements org.libelektra.Plugin.

## ◆ set()

int org.libelektra.NativePlugin.set | ( | KeySet | keySet,
|  | Key | errorKey
| ) |  | throws KDBException
| inline

Lets the plugin transform the given KeySet.

Parameters

  keySet | The KeySet to transform
  errorKey | must be a valid key, e.g. created with Key.create()

Returns
  0 if success or -1 otherwise

Exceptions

  KDBException | if return value was -1
  IllegalStateException | if `keySet` or `errorKey` has already been released

Implements org.libelektra.Plugin.

The documentation for this class was generated from the following file:

- NativePlugin.java